unit TableClientMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus;

type
  TForm1 = class(TForm)
    SG: TStringGrid;
    OD: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open: TMenuItem;
    N1: TMenuItem;
    Exit: TMenuItem;
    CopyTableFromServer: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure CopyTableFromServerClick(Sender: TObject);
  private
    TableServer: Variant;
  end;

var
  Form1: TForm1;

implementation

uses
  Registry, OLEAuto;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with TRegistry.Create do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      if not OpenKey('Software\Borland\Delphi\2.0', False) then
        raise Exception.Create('Cannot locate demo data directory');
      OD.InitialDir := ReadString('RootDir') + '\Demos\Data';
    finally
      Free
    end;
  TableServer := CreateOLEObject('TableServer.TableProxy');
end;

procedure TForm1.OpenClick(Sender: TObject);
begin
  if OD.Execute then
  begin
    Screen.Cursor := crHourGlass;
    Self.Enabled := False;
    try
      TableServer.Close;
      TableServer.DatabaseName := ExtractFilePath(OD.FileName);
      TableServer.TableName := ExtractFileName(OD.FileName);
      TableServer.Open
    finally
      Self.Enabled := True;
      Screen.Cursor := crDefault;
    end;
  end;
  CopyTableFromServer.Enabled := True
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Application.Terminate
end;

procedure TForm1.CopyTableFromServerClick(Sender: TObject);
var
  Data: Variant;
  InnerLoop, OuterLoop: Integer;
begin
  Data := TableServer.TableData;
  if not VarIsArray(Data) then
    raise Exception.Create('Bogus data returned from server');
  SG.ColCount := VarArrayHighBound(Data, 1) + 1;
  SG.RowCount := VarArrayHighBound(Data, 2) + 1;
  SG.FixedCols := 1;
  SG.FixedRows := 1;
  SG.ColWidths[0] := 0;
  for OuterLoop := 0 to SG.RowCount - 1 do
    for InnerLoop := 0 to SG.ColCount - 1 do
      SG.Cells[InnerLoop + 1, OuterLoop] := Data[InnerLoop, OuterLoop]
end;

end.
