unit IntfUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  IHello = interface(IUnknown)
  ['{40745C41-C32C-11D1-96E6-444553540000}']
    procedure SayHi;
  end;

  IHelloGoodbye = interface(IHello)
  ['{40745C42-C32C-11D1-96E6-444553540000}']
    procedure SayBye;
  end;

  THello1 = class(TInterfacedObject, IHello)
  public
    constructor Create;
    destructor Destroy; override;
    procedure SayHi;
  end;

  THello2 = class(TInterfacedObject, IHello, IHelloGoodbye)
    procedure IHello.SayHi = SayHello;
    procedure IHelloGoodbye.SayHi = SayHello;
  public
    constructor Create;
    destructor Destroy; override;
    procedure SayHello;
    procedure SayBye;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

constructor THello1.Create;
begin
  inherited;
  ShowMessage('Constructed a ' + ClassName)
end;

destructor THello1.Destroy;
begin
  ShowMessage('Destroyed a ' + ClassName);
  inherited
end;

procedure THello1.SayHi;
begin
  ShowMessage('Hello')
end;

constructor THello2.Create;
begin
  inherited;
  ShowMessage('Constructed a ' + ClassName)
end;

destructor THello2.Destroy;
begin
  ShowMessage('Destroyed a ' + ClassName);
  inherited
end;

procedure THello2.SayHello;
begin
  ShowMessage('Yo.')
end;

procedure THello2.SayBye;
begin
  ShowMessage('Bye')
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Hello: IHello;
  HelloBye: IHelloGoodbye;
begin
  Hello := THello1.Create;
  Hello.SayHi;
  if Hello.QueryInterface(IHelloGoodbye, HelloBye) = 0 then
    HelloBye.SayBye;
  Hello := THello2.Create;
  if Hello.QueryInterface(IHelloGoodbye, HelloBye) = 0 then
    HelloBye.SayBye;
  //(Hello as IHelloGoodbye).SayBye
end;

end.
