unit CopyU1;

interface

procedure FileCopy(const InFileName, OutFileName: String);

implementation

uses
  SysUtils;

procedure FileCopy(const InFileName, OutFileName: String);
const
  BufSize = 8 * 4096; { 32kb }
type
  PBuffer = ^TBuffer;
  TBuffer = array[1..BufSize] of Byte;
var
  Size: Cardinal;
  Buffer: PBuffer;
  InFile, OutFile: File;
begin
  if InFileName = OutFileName then
    raise EInOutError.Create('File cannot be copied onto itself')
  else
  begin
    Buffer := nil;
    Assign(InFile, InFileName);
    Reset(InFile, 1);
    try
      Assign(OutFile, OutFileName);
      Rewrite(OutFile, 1);
      try
        New(Buffer);
        repeat
          BlockRead(InFile, Buffer^, BufSize, Size);
          BlockWrite(OutFile, Buffer^, Size)
        until Size < BufSize;
        FileSetDate(TFileRec(OutFile).Handle,
          FileGetDate(TFileRec(InFile).Handle));
      finally
        if Buffer <> nil then
          Dispose(Buffer);
        CloseFile(OutFile)
      end;
    finally
      CloseFile(InFile);
    end
  end
end;

end.
